Index: cprs/trunk/CPRS-Chart/Orders/fODMeds.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODMeds.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODMeds.pas	(revision 829)
@@ -1524,4 +1752,13 @@
         if chkPRN.Checked = True then grdDoses.Cells[COL_CHKXPRN,i] := '1';
         grdDoses.Cells[COL_DURATION, i] := IValueFor('DAYS', i);
+        if FInptDlg then
+          begin
+            if IValueFor('ADMIN', i) <> '' then grdDoses.Cells[COL_ADMINTIME, i] := IValueFor('ADMIN', i)
+            else if cboSchedule.ItemIndex > -1 then
+               grdDoses.Cells[COL_ADMINTIME, i] := Piece(cboSchedule.Items.Strings[cboSchedule.itemIndex],U,4)
+            else grdDoses.Cells[COL_ADMINTIME, i] := '';
+            if grdDoses.Cells[COL_ADMINTIME, i] = '' then grdDoses.Cells[COL_ADMINTIME, i] := 'Not Defined';
+            if FAdminTimeText <> '' then grdDoses.Cells[COL_ADMINTIME, i] := FAdminTimeText;
+          end;
         if      IValueFor('CONJ', i) = 'A' then x := 'AND'
         else if IValueFor('CONJ', i) = 'T' then x := 'THEN'
@@ -1543,9 +1780,10 @@
       SetControl(cboRoute,  'ROUTE',     1);
       SetSchedule(IValueFor('SCHEDULE',  1));
-      if (cboSchedule.Text = '') and FIsQuickOrder then
+      if (cboSchedule.Text = '') and (FIsQuickOrder) and (NSSchedule = False) then
       begin
         cboSchedule.SelectByID(TempSch);
         cboSchedule.Text := TempSch;
       end;
+      if (cboSchedule.Text = '') and (FIsQuickOrder) and (NSSchedule = True) then cboSchedule.ItemIndex := -1;
       if ((cboSchedule.Text = 'OTHER') and FIsQuickOrder)  then
          FNSSOther := True;
@@ -1588,5 +1826,5 @@
       AResponse := Responses.FindResponseByName('PICKUP', 1);
       if AResponse <> nil then SetPickup(AResponse.IValue);
-      if FIsQuickOrder then
+      if (FIsQuickOrder) and (FOrderAction = ORDER_QUICK) then
       begin
         if not QOHasRouteDefined(Responses.QuickOrder) then
@@ -1603,9 +1841,9 @@
       end;
       if ValueOf(FLD_PICKUP) = '' then SetPickup(FLastPickup);
-      AResponse := Responses.FindResponseByName('SC',     1);
-      if AResponse <> nil then chkSC.Checked := AResponse.IValue = '1';
+//      AResponse := Responses.FindResponseByName('SC',     1);
+      Responses.FindResponseByName('SC',     1);
     end; {if FInptDlg..else}
   end; {with}
-  if FInptDlg then
+ if FInptDlg then
   begin
     x := ValueOfResponse(FLD_SCHEDULE, 1);
@@ -1704,4 +1942,6 @@
   lblSchedule.Visible := True;
   cboSchedule.Visible := True;
+  if FInptDlg = True then lblAdminSch.Visible := True
+  else lblAdminSch.Visible := false;
   chkPRN.Visible := True;
   ActiveControl := cboDosage;
@@ -1718,5 +1958,5 @@
     begin
       DestCombo.Items.Clear;
-      DestCombo.Items.Assign(SrcCombo.Items);
+      FastAssign(SrcCombo.Items, DestCombo.Items);
       DestCombo.ItemIndex := SrcCombo.ItemIndex;
       DestCombo.Text := Piece(SrcCombo.Text, TAB, 1);
@@ -1739,4 +1979,14 @@
         else cnt := cnt+1;
       end;
+    if (index = -1) and (Text <> '') then
+       begin
+         for I := 0 to DestCombo.Items.Count - 1 do
+         if Piece(DestCombo.Items.Strings[i],U,1) = Text then
+            begin
+               DestCombo.ItemIndex := i;
+               DestCombo.Text := Text;
+               Exit;
+            end;
+       end;
     end;
   end;
@@ -1815,40 +2065,78 @@
 procedure TfrmODMeds.SetSchedule(const x: string);
 var
-NonPRNPart: string;
-begin
-  cboSchedule.ItemIndex := -1;
-  //AGP change CQ 10593, remove code to match the new expected first dose code
-  //PSI-05-026
- (* if Pos('PRN', x) > 0 then
-  begin
-    NonPRNPart := Trim(Copy(x, 1, Pos('PRN', x) - 1));
-    cboSchedule.SelectByID(NonPRNPart);
-    if cboSchedule.ItemIndex < 0 then
-    begin
-      if NSSchedule then
-      begin
-        chkPRN.Checked := False;
-        cboSchedule.Text := '';
-      end else
-      begin
-        chkPRN.Checked := True;
-        cboSchedule.Items.Add(NonPRNPart);
-        cboSchedule.Text := NonPRNPart;
+NonPRNPart,tempSch, tempText: string;
+begin
+    //AGP Change 27.72 if schedule matches why goes through and reprocess the same info?
+    if cboSchedule.ItemIndex > -1 then
+      begin
+        tempText := Piece(cboSchedule.Items.Strings[cboSchedule.itemindex], U, 1);
+        if tempText = x then exit;
+        if (Pos('PRN',x)>0) and (chkPRN.Checked = true) then
+          begin
+             NonPRNPart := Trim(Copy(x, 1, Pos('PRN', x) - 1));
+             if nonPRNPart = tempText then exit;
+          end;
       end;
-    end else
-      chkPRN.Checked := True;
-  end else
-  begin  *)
-    chkPRN.Checked := False;
+    cboSchedule.ItemIndex := -1;
+    if chkPRN.Checked = True then chkPRN.Checked := False;
     cboSchedule.SelectByID(x);
-    if cboSchedule.ItemIndex < 0 then
-    begin
-      if NSSchedule then
-      begin
-        cboSchedule.Text := '';
+    if cboSchedule.ItemIndex > -1 then exit;
+   // if cboSchedule.ItemIndex < 0 then
+    //begin
+      //if NSSchedule then
+      //begin
+      //  cboSchedule.Text := '';
+      //end
+      if FInptDlg then
+        begin
+          if (Pos('@', x) > 0) then
+            begin
+            tempSch := Piece(x, '@', 2);
+            cboSchedule.SelectByID(tempSch);
+            if cboSchedule.ItemIndex > -1 then
+              begin
+                tempSch := Piece(x, '@', 1) + '@' + cboSchedule.Items.Strings[cboSchedule.itemindex];
+                cboSchedule.Items.Add(tempSch);
+                cboSchedule.Text := (Piece(tempSch,U,1));
+                cboSchedule.SelectByID(Piece(tempSch,u,1));
+                EXIT;
+              end;
+            if Pos('PRN', tempSch) > 0 then
+              begin
+                NonPRNPart := Trim(Copy(tempSch, 1, Pos('PRN', tempSch) - 1));
+                cboSchedule.SelectByID(NonPRNPart);
+                if cboSchedule.ItemIndex > -1 then
+                  begin
+                    tempSch := Piece(x, '@', 1) + '@' + cboSchedule.Items.Strings[cboSchedule.itemindex];
+                    cboSchedule.Items.Add(tempSch);
+                    cboSchedule.Text := (Piece(tempSch,U,1));
+                    cboSchedule.SelectByID(Piece(tempSch,u,1));
+                    chkPRN.Checked := True;
+                    EXIT;
+                  end
+                else
+                  begin
+                    NonPRNPart := Trim(Copy(x, 1, Pos('PRN', x) - 1));
+                    chkPRN.Checked := true;
+                    tempSch := NonPRNPart + U + U + U + Piece(NonPRNPart, '@', 2);
+                    cboSchedule.Items.Add(tempSch);
+                    cboSchedule.SelectByID(Piece(tempSch, U, 1));
+                    EXIT;
+                  end;
+              end;
+              cboSchedule.Items.Add(X + U + U + U + Piece(x, '@', 2));
+              cboSchedule.Text := x;
+              cboSchedule.SelectByID(x);
+              EXIT;
+            end
+        else if Pos('PRN', x) > 0 then
+          begin
+            NonPRNPart := Trim(Copy(x, 1, Pos('PRN', x) - 1));
+            chkPRN.Checked := True;
+            cboSchedule.SelectByID(NonPRNPart);
+            if cboSchedule.ItemIndex > -1 then  EXIT;
+          end;
       end
-      else
-      begin
-      if Pos('PRN', x) > 0 then
+      else if Pos('PRN', x) > 0 then
         begin
          NonPRNPart := Trim(Copy(x, 1, Pos('PRN', x) - 1));
@@ -1861,9 +2149,7 @@
          EXIT;
         end;
-         cboSchedule.Items.Add(x);
-         cboSchedule.Text := x;
-         cboSchedule.SelectByID(x);
-      end;
-  end;
+      cboSchedule.Items.Add(x);
+      cboSchedule.Text := x;
+      cboSchedule.SelectByID(x);
 end;
 
@@ -1872,5 +2158,5 @@
 var
   //text,x, tmpsch: string;
-  text, x: string;
+  text, tmpAdmin, x: string;
   reset: integer;
 begin
@@ -1896,4 +2182,5 @@
   TI_DOSE:    begin
                 cboXSchedule.Clear;                       // Added to Fix CQ: 9603
+                cboXDosage.Clear;
                 // clean up responses?
                 FSuppressMsg := FOrigiMsgDisp;
@@ -1912,4 +2199,13 @@
                 FSuppressMsg := FOrigiMsgDisp;
                 if reset = 1 then exit;
+               (*  AGP Change admin wrap 27.73
+                tmpAdmin := Piece(self.lblAdminSch.text, ':', 2);
+                tmpAdmin := Copy(tmpAdmin,2,Length(tmpAdmin)); *)
+                tmpAdmin := lblAdminSchGetText;
+                if FAdminTimeText <> '' then
+                  begin
+                    tmpAdmin := FAdminTimeText;
+                    if FAdminTimeText <> 'Not defined for Clinic Locations' then self.lblAdminSch.Visible := False;
+                  end;               
                 ShowControlsComplex;
                 ResetOnTabChange;
@@ -1917,4 +2213,5 @@
                 txtNss.Visible := False;
                 x := cboXDosage.Text + TAB;
+                if LeftStr(x,1) = '.' then x := '';
                 with cboXDosage   do if ItemIndex > -1 then x := x + Items[ItemIndex];
                 grdDoses.Cells[COL_DOSAGE,   1] := x;
@@ -1925,10 +2222,49 @@
                 with cboXSchedule do if ItemIndex > -1 then x := x + Items[ItemIndex];
                 grdDoses.Cells[COL_SCHEDULE, 1] := x;
-                UpdateStartExpires(ValFor(VAL_SCHEDULE,1));
+                //AGP Change 27.1 handle PRN not showing in schedule panel if a dose is not selected.
+                if FSmplPRNChkd then
+                  begin
+                    pnlXSchedule.Tag := 1;
+                    self.chkXPRN.Checked := True;
+                  end;
+                if FInptDLG then UpdateStartExpires(ValFor(VAL_SCHEDULE,1));
                 ControlChange(Self);
              end; {TI_COMPLEX}
   end; {case}
-end;
-
+  if ScreenReaderSystemActive then
+    GetScreenReader.Speak(tabDose.Tabs[tabDose.TabIndex] + ' tab');
+end;
+
+
+function TfrmODMeds.lblAdminSchGetText: string;
+var
+tempstr: string;
+i: integer;
+begin
+  result := '';
+  if self.lblAdminSch.Text = '' then exit;
+  tempstr := '';
+  if self.lblAdminSch.Lines.Count > 1 then
+    begin
+      for i := 0 to self.lblAdminSch.Lines.Count - 1 do
+        tempstr := tempStr + self.lblAdminSch.Lines.Strings[i];
+    end
+  else if self.lblAdminSch.Lines.Count = 1 then
+       begin
+         tempstr := self.lblAdminSch.Text;
+       end;
+  Result := Piece(tempStr,':',2);
+  Result := Copy(Result,2,Length(Result));
+end;
+
+procedure TfrmODMeds.lblAdminSchSetText(str: string);
+var
+cutoff: integer;
+begin
+  cutoff := lblAdminSch.width div MainFontWidth;
+  if Length(str) > cutoff then self.lblAdminSch.Text := Copy(str, 1, cutoff) + CRLF +
+                                              Copy(str, cutoff + 1, Length(str))
+  else self.lblAdminSch.Text := str;
+end;
 
 procedure TfrmODMeds.lblGuidelineClick(Sender: TObject);
@@ -2010,14 +2346,42 @@
 
 procedure TfrmODMeds.cboDosageChange(Sender: TObject);
-begin
-  inherited;
+var
+temp1,temp2: string;
+Count: integer;
+begin
+  inherited;
+  Count := Pos(U,cboDosage.Text);
+  if Count > 0 then
+    begin
+      temp1 := copy(cboDosage.Text,0,count-1);
+      temp2 := copy(cboDosage.Text,count+1,Length(cboDosage.text));
+      infoBox('An ^ is not allowed in the dosage value', 'Dosage Warning', MB_OK);
+      cboDosage.Text := temp1 + temp2;
+    end;
   UpdateRelated;
 end;
 
 procedure TfrmODMeds.cboDosageExit(Sender: TObject);
-begin
-  inherited;
+var
+str: string;
+begin
+  inherited;
+  str := cboDosage.Text;
   if (length(cboDosage.Text)<1) then
-    cboDosage.ItemIndex := -1;
+      cboDosage.ItemIndex := -1;
+ (* Probably not needed here since this on validation check on accept
+  if (LeftStr(cboDosage.Text,1)='.') then
+       begin
+         infoBox('Dosage must have a leading numeric value','Invalid Dosage',MB_OK);
+         if self.tabDose.TabIndex = TI_DOSE then cboDosage.SetFocus;
+         Exit;
+       end; *)
+  if (length(cbodosage.Text)>0) and (cboDosage.ItemIndex > -1) and
+    (Piece(cboDosage.Items.Strings[cboDosage.ItemIndex],U,5) <> Piece(cboDosage.Text,tab,1)) then
+    begin
+      cboDosage.ItemIndex := -1;
+      cboDosage.Text := Piece(str, tab, 1);
+      UpdateRelated(false);
+    end;
   if ActiveControl = memMessage then
   begin
@@ -2082,4 +2446,30 @@
     if length(trim(othSch)) > 1 then
     begin
+      othSch := othSch + U + U + NSSScheduleType + U + NSSAdminTime;
+      cboSchedule.Items.Add(othSch);
+      idx := cboSchedule.Items.IndexOf(Piece(OthSch, U, 1));
+      cboSchedule.ItemIndex := idx;
+    end;
+  end
+  else
+    begin
+      NSSAdminTime := '';
+      FNSSScheduleType := '';
+    end;
+  UpdateRelated(False);
+end;
+
+
+procedure TfrmODMeds.cboScheduleChange(Sender: TObject);
+var
+  othSch: string;
+  idx : integer;
+begin
+  inherited;
+  if  (FInptDlg) and (cboSchedule.Text = 'OTHER') then
+  begin
+    othSch := CreateOtherScheduel;
+    if length(trim(othSch)) > 1 then
+    begin
       cboSchedule.Items.Add(othSch);
       idx := cboSchedule.Items.IndexOf(OthSch);
@@ -2087,26 +2477,4 @@
     end;
   end;
-  UpdateRelated(False);
-end;
-
-procedure TfrmODMeds.cboScheduleChange(Sender: TObject);
-var
-  othSch: string;
-  idx : integer;
-begin
-  inherited;
-  if  (FInptDlg) and (cboSchedule.Text = 'OTHER') then
-  begin
-    othSch := CreateOtherScheduel;
-    if length(trim(othSch)) > 1 then
-    begin
-      cboSchedule.Items.Add(othSch);
-      idx := cboSchedule.Items.IndexOf(OthSch);
-      cboSchedule.ItemIndex := idx;
-    end;
-  end;
-//Remove Deletion of Text, since we are changing the validation to be on exit of the control.
-{  if (Length(cboSchedule.Text)>0) and (cboSchedule.ItemIndex < 0) and FInptDlg then
-    cboSchedule.Text := '';}
   FScheduleChanged := true;
   UpdateRelated;
@@ -2178,22 +2546,18 @@
   inherited;
   if Changing then Exit;
-  if not Showing then Exit;
+  if not Showing then
+    begin
+       if (FISQuickOrder = true) and (txtQuantity.Text = '0') and (FLastQuantity > 0) and (FLastQuantity <> StrtoInt64(txtQuantity.text)) then
+         begin
+           Changing := True;
+           txtQuantity.Text := FloattoStr(FLastQuantity);
+           Changing := False;
+         end;
+       Exit;
+    end;
   if FNoZERO = False then FNoZERO := True;
   // if value = 0, change probably caused by the spin button
   if txtQuantity.Text <> '0' then txtQuantity.Tag := 1;
   UpdateRelated;
-end;
-
-procedure TfrmODMeds.chkSCEnter(Sender: TObject);
-begin
-  inherited;
-  pnlMessage.TabOrder := chkSC.TabOrder+1;
-  DispOrderMessage(RatedDisabilities);
-end;
-
-procedure TfrmODMeds.chkSCClick(Sender: TObject);
-begin
-  inherited;
-  chkSC.Tag := 1;
 end;
 
@@ -2315,4 +2679,5 @@
 end;
 
+
 function TfrmODMeds.ConstructedDoseFields(const ADose: string; PrependName: Boolean = FALSE): string;
 var
@@ -2441,5 +2806,5 @@
 begin
   Result := '';
-  if FInptDlg then                                // inpatient dialog
+ if FInptDlg then                                // inpatient dialog
   begin
     DrugOK := True;
@@ -2491,5 +2856,5 @@
             end
             else DoseUnits := Piece(DoseFields, '&', 2);
-            if not AnsiSameText(DoseUnits, DrugUnits) then DrugOK := False;
+            if (not AnsiSameText(DoseUnits, DrugUnits)) then DrugOK := False;
           end;
           if not DrugOK then
@@ -2536,5 +2901,6 @@
   FUpdated := FALSE;
   Responses.Clear;
-  Responses.Update('ORDERABLE',  1, IntToStr(txtMed.Tag), txtMed.Text);
+  if self.MedName = '' then Responses.Update('ORDERABLE',  1, IntToStr(txtMed.Tag), txtMed.Text)
+  else Responses.Update('ORDERABLE',  1, IntToStr(txtMed.Tag), self.MedName);
   DoseList := TStringList.Create;
   case tabDose.TabIndex of
@@ -2579,4 +2945,17 @@
                                 else Responses.Update('ROUTE',    1, '', x);
       x := ValueOf(FLD_SCHEDULE);    Responses.Update('SCHEDULE', 1, x,  x);
+      if FInptDlg then
+        begin
+        (* AGP Change Admin Time Wrap 27.73
+          x := Piece(self.lblAdminSch.text,':',2);
+          x := Copy(x,2,Length(x));  *)
+          x := lblAdminSchGetText;
+          if FAdminTimeText <> '' then x := '';
+          if x = 'Not Defined' then x := '';
+          Responses.Update('ADMIN',1,x,x);
+          X := Valueof(FLD_SCHED_TYP);
+          if self.chkPRN.Checked = true then x := 'P';
+          Responses.Update('SCHTYPE',1,x,x);
+        end;
     end;
   TI_COMPLEX:
@@ -2627,4 +3006,14 @@
         end;
         x := ValueOf(FLD_DURATION, i);  Responses.Update('DAYS',     i, UpperCase(x), x);
+        if FInptDlg then
+          begin
+            x := ValFor(VAL_ADMINTIME,i);
+            if FAdminTimeText <> '' then x := '';
+            if x = 'Not Defined' then x := '';
+            Responses.Update('ADMIN',i,x,x);
+            x := Valueof(FLD_SCHED_TYP, i);
+            if ValFor(VAL_CHKXPRN, i) = '1' then x := 'P';
+            Responses.Update('SCHTYPE', i, x, x);
+          end;
         x := ValueOf(FLD_SEQUENCE, i);
         if      Uppercase(x) = 'THEN'   then x := 'T'
@@ -2674,15 +3063,16 @@
   with grdDoses do
     case FieldID of
-    COL_DOSAGE   : Result := Piece(Cells[COL_DOSAGE,   ARow], TAB, 1);
-    COL_ROUTE    : Result := Piece(Cells[COL_ROUTE,    ARow], TAB, 1);
-    COL_SCHEDULE : Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
-    COL_DURATION : Result := Piece(Cells[COL_DURATION, ARow], TAB, 1);
-    COL_SEQUENCE : Result := Piece(Cells[COL_SEQUENCE, ARow], TAB, 1);
-    VAL_DOSAGE   : Result := Piece(Cells[COL_DOSAGE,   ARow], TAB, 2);
-    VAL_ROUTE    : Result := Piece(Cells[COL_ROUTE,    ARow], TAB, 2);
-    VAL_SCHEDULE : Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
-    VAL_DURATION : Result := Piece(Cells[COL_DURATION, ARow], TAB, 1);
-    VAL_SEQUENCE : Result := Piece(Cells[COL_SEQUENCE, ARow], TAB, 1);
-    VAL_CHKXPRN  : Result := Cells[COL_CHKXPRN, ARow];
+    COL_DOSAGE    : Result := Piece(Cells[COL_DOSAGE,   ARow], TAB, 1);
+    COL_ROUTE     : Result := Piece(Cells[COL_ROUTE,    ARow], TAB, 1);
+    COL_SCHEDULE  : Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
+    COL_DURATION  : Result := Piece(Cells[COL_DURATION, ARow], TAB, 1);
+    COL_SEQUENCE  : Result := Piece(Cells[COL_SEQUENCE, ARow], TAB, 1);
+    VAL_DOSAGE    : Result := Piece(Cells[COL_DOSAGE,   ARow], TAB, 2);
+    VAL_ROUTE     : Result := Piece(Cells[COL_ROUTE,    ARow], TAB, 2);
+    VAL_SCHEDULE  : Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
+    VAL_DURATION  : Result := Piece(Cells[COL_DURATION, ARow], TAB, 1);
+    VAL_ADMINTIME : Result := Piece(Cells[COL_ADMINTIME, ARow], TAB, 1);
+    VAL_SEQUENCE  : Result := Piece(Cells[COL_SEQUENCE, ARow], TAB, 1);
+    VAL_CHKXPRN   : Result := Cells[COL_CHKXPRN, ARow];
     end;
 end;
@@ -2730,5 +3120,5 @@
 function TfrmODMeds.DurationToDays: Integer;
 var
-  i, DoseMinutes, TotalMinutes: Integer;
+  i, DoseMinutes, AndMinutes, TotalMinutes: Integer;
   AllRows: Boolean;
   Days: Extended;
@@ -2743,4 +3133,5 @@
   if not AllRows then Exit;
 
+  AndMinutes := 0;
   TotalMinutes := 0;
   with grdDoses do for i := 1 to Pred(RowCount) do
@@ -2754,6 +3145,21 @@
       if Piece(x, ' ', 2) = 'HOURS'   then DoseMinutes := ExtractInteger(x) * 60;
       if Piece(x, ' ', 2) = 'MINUTES' then DoseMinutes := ExtractInteger(x);
-      TotalMinutes := TotalMinutes + DoseMinutes;
-    end;
+      // Determine how TotalMinutes should be calculated based on conjunction
+      if ValFor(COL_SEQUENCE, i) <> 'AND' then  // 'THEN', 'EXCEPT', or ''
+      begin
+        if AndMinutes = 0 then TotalMinutes := TotalMinutes + DoseMinutes;
+        if AndMinutes > 0 then
+        begin
+          if AndMinutes < DoseMinutes then AndMinutes := DoseMinutes;
+          TotalMinutes := TotalMinutes + AndMinutes;
+          AndMinutes := 0;
+        end;
+        if ValFor(COL_SEQUENCE, i) = 'EXCEPT' then break;  //quit out of For Loop to stop counting TotalMinutes
+      end;
+      if (ValFor(COL_SEQUENCE, i) = 'AND') then
+        if AndMinutes < DoseMinutes then AndMinutes := DoseMinutes;
+    end;
+  if AndMinutes > 0 then TotalMinutes := TotalMinutes + AndMinutes;
+
   Days := TotalMinutes / 1440;
   if Days > Int(Days) then Days := Days + 1;
@@ -2768,4 +3174,5 @@
   REL_DURATION = 0.16;
   REL_ANDTHEN  = 0.10;
+  REL_ADMINTIME = 0.16;
 var
   i, ht, RowCountShowing: Integer;
@@ -2777,9 +3184,24 @@
     i := grdDoses.Width - 12;                 // 12 = 4 pixel margin + 8 pixel column 0
     i := i - GetSystemMetrics(SM_CXVSCROLL);  // compensate for appearance of scroll bar
-    ColWidths[1] := Round(REL_DOSAGE   * i);  // dosage
-    ColWidths[2] := Round(REL_ROUTE    * i);  // route
-    ColWidths[3] := Round(REL_SCHEDULE * i);  // schedule
-    ColWidths[4] := Round(REL_DURATION * i);  // duration
-    ColWidths[5] := Round(REL_ANDTHEN  * i);  // and/then
+    if (not FinptDlg) or (FAdminTimeText = 'Not defined for Clinic Locations') then
+      begin
+        ColWidths[1] := Round(REL_DOSAGE   * i);  // dosage
+        ColWidths[2] := Round(REL_ROUTE    * i);  // route
+        ColWidths[3] := Round(REL_SCHEDULE * i);  // schedule
+        ColWidths[4] := Round(REL_DURATION * i);  // duration
+        ColWidths[5] := Round(0  * i);  // administration time
+        grdDoses.TabStops[5] := False;
+        ColWidths[6] := Round(REL_ANDTHEN  * i);  // and/then
+      end
+    else
+      begin
+        ColWidths[1] := Round(0.35    * i);  // dosage
+        ColWidths[2] := Round(0.10     * i);  // route
+        ColWidths[3] := Round(0.19  * i);  // schedule
+        ColWidths[4] := Round(0.12  * i);  // duration
+        ColWidths[5] := Round(0.16 * i);  // administration time
+        grdDoses.TabStops[5] := True;
+        ColWidths[6] := Round(0.08   * i);  // and/then
+      end;
     // adjust height of grid to not show partial rows
     ht := pnlBottom.Top - Top - 6;
@@ -2796,5 +3218,6 @@
       COL_SCHEDULE:ColControl := pnlXSchedule;
       COL_DURATION:ColControl := pnlXDuration;
-      COL_SEQUENCE:ColControl := pnlXSequence;
+      COL_ADMINTIME:ColControl := pnlXAdminTime;
+      COL_SEQUENCE:ColControl := cboXSequence;
     end; {case}
 
@@ -2844,4 +3267,6 @@
   COL_ROUTE:    with cboXRoute    do if Items.Count > 0 then DroppedDown := True;
   COL_SCHEDULE: with cboXSchedule do if Items.Count > 0 then DroppedDown := True;
+  COL_SEQUENCE: with cboXSequence do if Items.Count > 0 then DroppedDown := True;
+                                     
   end;
   FDropColumn := -1;
@@ -2977,7 +3402,6 @@
                   end; *)
                   Changing := FALSE;
-                  pnlXSequence.Tag := ARow;
+                  cboXSequence.Tag := ARow;
                   PlaceControl(pnlXSchedule);
-                  //cboXSchedule.SetFocus;
                   FDropColumn := COL_SCHEDULE;
                   if AChar <> #0 then PostMessage(Handle, UM_DELAYEVENT, Ord(AChar), COL_SCHEDULE);
@@ -3005,13 +3429,14 @@
                 end;
   COL_SEQUENCE: begin
-                  x := ValFor(COL_SEQUENCE, ARow);
-                  //if x = '' then x := 'and';  AGP Change 26.46 remove for CQ 9535
-                  btnXSequence.Caption := x;
-                  pnlXSequence.Caption := btnXSequence.Caption;
-                  pnlXSequence.Tag := ARow;
+                  SynchCombo(cboXSequence, ValFor(VAL_SEQUENCE, ARow), ValFor(COL_SEQUENCE, ARow));
+                  cboXSequence.Tag := ARow;
                   ARow1 := ARow;
-                  PlaceControl(pnlXSequence);
-                  btnXSequence.Width := pnlXSequence.Width;
+                  PlaceControl(cboXSequence);
+                  FDropColumn := COL_SEQUENCE;
+                  if AChar <> #0 then PostMessage(Handle, UM_DELAYEVENT, Ord(AChar), COL_SEQUENCE);
                 end;
+  COL_ADMINTIME: BEGIN
+                 pnlXAdminTime.OnClick(pnlXAdminTime);
+                 end;
   end; {case ACol}
 end;
@@ -3028,4 +3453,5 @@
                    txtXDuration.SelStart := 1;
                  end;
+  COL_SEQUENCE : FindInCombo(Chr(Message.WParam), cboXSequence);
   end;
 end;
@@ -3041,8 +3467,19 @@
 
 procedure TfrmODMeds.cboXDosageChange(Sender: TObject);
+var
+temp1,temp2: string;
+count: integer;
 begin
   inherited;
   if not Changing and (cboXDosage.ItemIndex < 0) then
   begin
+    Count := Pos(U,cboXDosage.Text);
+    if Count > 0 then
+      begin
+        temp1 := copy(cboXDosage.Text,0,count-1);
+        temp2 := copy(cboXDosage.Text,count+1,Length(cboXDosage.text));
+        infoBox('An ^ is not allowed in the dosage value', 'Dosage Warning', MB_OK);
+        cboXDosage.Text := temp1 + temp2;
+      end;
     grdDoses.Cells[COL_DOSAGE, cboXDosage.Tag] := cboXDosage.Text;
     UpdateRelated;
@@ -3085,23 +3522,50 @@
 
 procedure TfrmODMeds.cboXDosageExit(Sender: TObject);
-begin
-  inherited;
-  cboXDosageClick(Self);
-  cboXDosage.Tag := -1;
-  cboXDosage.Hide;
-  UpdateRelated;
-  RestoreDefaultButton;
-  RestoreCancelButton;
-  if (pnlMessage.Visible) and (memMessage.TabStop)  then
-  begin
-    pnlMessage.Parent := grdDoses.Parent;
-    pnlMessage.TabOrder := grdDoses.TabOrder;
-    ActiveControl := memMessage;
-  end
-  else if grdDoses.Showing then
-    ActiveControl := grdDoses
-  else
-    ActiveControl := cboDosage;
-end;
+var
+//tempTag: integer;
+str: string;
+begin
+  inherited;
+  if cboXDosage.Showing then
+  begin
+    cboXDosageClick(Self);
+    str := cboXDosage.Text;
+    //tempTag := cboXDosage.Tag;
+    //cboXDosage.Tag := -1;
+    cboXDosage.Hide;
+    UpdateRelated;
+    RestoreDefaultButton;
+    RestoreCancelButton;
+   (*Probably not needed here since on validation check on accept
+    if (LeftStr(cboXDosage.Text,1)='.') and (self.tabDose.TabIndex = TI_COMPLEX) then
+         begin
+           infoBox('Dosage must have a leading numeric value','Invalid Dosage',MB_OK);
+           //cboXDosage.Tag := tempTag;
+           cboXDosage.Show;
+           cboXDosage.SetFocus;
+           Exit;
+         end;  *)
+    if (length(cboxdosage.Text)>0) and (cboxDosage.ItemIndex > -1) and
+      (Piece(cboxDosage.Items.Strings[cboxDosage.ItemIndex],U,5) <> Piece(cboxDosage.Text,'#',1)) then
+      begin
+        cboXDosage.ItemIndex := -1;
+        cboXDosage.Text := Piece(str, '#', 1);
+        self.grdDoses.Cells[COL_DOSAGE,self.grdDoses.row] := cboXDosage.Text;
+        UpdateRelated(false);
+      end;
+    if (pnlMessage.Visible) and (memMessage.TabStop)  then
+    begin
+      pnlMessage.Parent := grdDoses.Parent;
+      pnlMessage.TabOrder := grdDoses.TabOrder;
+      ActiveControl := memMessage;
+    end
+    else if grdDoses.Showing then
+      ActiveControl := grdDoses
+    else
+      ActiveControl := cboDosage;
+    end
+    else
+       cmdQuit.Click;
+  end;
 
 procedure TfrmODMeds.cboXRouteChange(Sender: TObject);
@@ -3175,16 +3639,16 @@
     if (FInptDlg) and (cboXSchedule.Text = 'OTHER') then
     begin
+      cboXSchedule.SelectByID('OTHER');
       othSch := CreateOtherScheduelComplex;
       if length(trim(othSch)) > 1 then
       begin
+        othSch := othSch + U + U + NSSScheduleType + U + NSSAdminTime;
         cboXSchedule.Items.Add(othSch);
-        idx := cboXSchedule.Items.IndexOf(OthSch);
+        idx := cboXSchedule.Items.IndexOf(Piece(OthSch, U, 1));
         cboXSchedule.ItemIndex := idx;
       end;
     end;
-  (* if chkXPRN.Checked then PRN := ' PRN' else PRN := '';
-    with cboXSchedule do if ItemIndex > -1
-      then x := Text + PRN + TAB + Items[ItemIndex]
-      else x := Text + PRN; *)
+  if pnlXSchedule.Tag = -1 then pnlXSchedule.Tag := self.grdDoses.Row;
+    //if pnlXSchedule.Tag = -1 then pnlXSchedule.Tag := self.grdDoses.Row;
     with cboXSchedule do if ItemIndex > -1
       then x := Text + TAB + Items[ItemIndex]
@@ -3192,4 +3656,6 @@
     grdDoses.Cells[COL_SCHEDULE, pnlXSchedule.Tag] := x;
     self.cboSchedule.Text := x;
+     //AGP Start Expired uncommented out the line
+    if FInptDlg then UpdateStartExpires(Piece(x, tab, 1));
     UpdateRelated;
   end;
@@ -3198,19 +3664,21 @@
 procedure TfrmODMeds.cboXScheduleClick(Sender: TObject);
 var
-  x: string;
-begin
-  inherited;
-  //if chkXPRN.Checked then PRN := ' PRN' else PRN := '';
+  PRN,x: string;
+begin
+  inherited;
+  //agp change CQ 11015
+  if (chkXPRN.Checked) then PRN := ' PRN' else PRN := '';
+  with cboXSchedule do
+    begin
+      if RightStr(Text,3) = 'PRN' then PRN := '';
+      if ItemIndex > -1 then x := Text + PRN + TAB + Items[ItemIndex]
+      else x := Text + PRN;
+    end;
  (* with cboXSchedule do if ItemIndex > -1
-    then x := Text + PRN + TAB + Items[ItemIndex]
-    else x := Text + PRN;  *)
-  with cboXSchedule do if ItemIndex > -1
     then x := Text + TAB + Items[ItemIndex]
-    else x := Text;
-   (* if (Pos('PRN',X)>0) and (pnlXSchedule.Tag = 1) then
-    if lblAdmintime.visible then
-      lblAdmintime.Caption := ''; *)
+    else x := Text;  *)
   grdDoses.Cells[COL_SCHEDULE, pnlXSchedule.Tag] := x;
-  UpdateStartExpires(x);
+  //AGP Start Expired uncommented out the line
+  UpdateStartExpires(Piece(x, tab, 1));
   UpdateRelated;
 end;
@@ -3248,4 +3716,18 @@
   else
     ActiveControl := cboDosage;
+  //AGP Start Expired commented out the line
+  //updateStartExpires(valFor(COL_SCHEDULE,self.grdDoses.Row));
+end;
+
+procedure TfrmODMeds.pnlXAdminTimeClick(Sender: TObject);
+var
+Str: string;
+begin
+  inherited;
+  if not FInptDlg then Exit;
+  
+  str := 'The Administration Times for this dose are: ' + CRLF + CRLF + VALFOR(VAL_ADMINTIME,grddoses.Row);
+  str := str + CRLF + CRLF + AdminTimeHelpText;
+  infoBox(str,'Administration Time Information',MB_OK);
 end;
 
@@ -3272,5 +3754,5 @@
     if (Code <> 0) {and (I=0)} then
     begin
-      ShowMessage('Please use numeric characters only.');
+      ShowMsg('Please use numeric characters only.');
       with txtXDuration do
       begin
@@ -3305,8 +3787,8 @@
                     begin
                         grdDoses.Cells[COL_DURATION, pnlXDuration.Tag] := '';
-                        pnlXSequence.Tag := ARow1;
-                        pnlXSequence.Caption := '';
-                        grdDoses.Cells[COL_SEQUENCE, pnlXSequence.Tag] := '';
-                        btnXSequence.Click;
+                        cboXSequence.Tag := ARow1;
+                        grdDoses.Cells[COL_SEQUENCE, cboXSequence.Tag] := '';
+                        cboXSequence.Text := '';
+                        cboXSequence.ItemIndex := -1;
                     end
                     else
